=== debian/changelog ===
nss (2:3.117-1) unstable; urgency=medium

  * New upstream release.
  * debian/libnss3.symbols: Add NSS_3.117 and NSSUTIL_3.117 symbol
    versions.

 -- Mike Hommey <glandium@debian.org>  Wed, 15 Oct 2025 16:34:17 +0900
