## nss 3.119

=== debian/changelog ===
nss (2:3.119-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Hommey <glandium@debian.org>  Wed, 10 Dec 2025 09:23:00 +0900
