=== debian/changelog ===
nss (2:3.120-1ubuntu1) resolute; urgency=medium

  * SECURITY UPDATE: integer overflow in platform-independent ghash
    - debian/patches/CVE-2026-2781.patch: properly cast len in
      nss/lib/freebl/gcm.c.
    - CVE-2026-2781

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 26 Feb 2026 12:49:32 -0500

nss (2:3.120-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Hommey <glandium@debian.org>  Wed, 14 Jan 2026 10:17:03 +0900
