## nss wins

=== Makefile ===
# 2.5.1 and earlier
# LIBS = -lnsl -lsocket

# 2.6
# LIBS = -lxnet

FLAGS += -fpic -DWITH_SYSLOG

NSSWINS_OBJ = nss_wins/nb_whats_your_name.o nss_wins/nss_wins.o nss_wins/wins_resolve.o

nss_wins/nss_wins.so.1: $(PARAM_OBJ) $(UBIQX_OBJ) $(LIBSMB_OBJ) $(LIB_OBJ) $(NSSWINS_OBJ)
	@echo "Linking $@"
	@$(CC) -O -shared -fpic -o $@ $(PARAM_OBJ) $(UBIQX_OBJ) $(LIBSMB_OBJ) $(LIB_OBJ) $(NSSWINS_OBJ) $(LIBS)
